; DPMI Termination Procedures Module

        TITLE   DEND

        INCLUDE SE.ASM

        .286P

CONST   SEGMENT WORD PUBLIC

CONST   ENDS

DATA    SEGMENT WORD PUBLIC
; Externals
        EXTRN   ExitProc:DWORD,ExitCode:WORD,ErrorAddr:DWORD
        EXTRN   PrefixSeg:WORD,InOutRes:WORD
        extrn   ErrAddr:dword,Terminator: dword
DATA    ENDS

DGROUP  GROUP   CONST,DATA

CODE    SEGMENT BYTE PUBLIC
        ASSUME  CS:CODE,DS:DGROUP

        PUBLIC  HaltTurbo,HaltError,Terminate

; RunError standard procedure
HaltError:
        POP     CX
        POP     BX
		 ;   pop ax
        JMP     SHORT Terminate

; Halt standard procedure
HaltTurbo:
        XOR     CX,CX
        XOR     BX,BX

; Terminate program
; In    AX    = Exit code
;       BX:CX = Error address (or NIL)
Terminate:
        MOV     DX,SEG DATA             ;Reset DS
        MOV     DS,DX
        STI                             ;Enable interrupts
        MOV     ExitCode,AX             ;Save exit code
        mov ErrAddr.ofs, cx
        mov ErrAddr.seg, bx

        jmp dword ptr Terminator

CODE    ENDS

        END
