; *******************************************************
; *                                                     *
; *     Turbo Pascal Run-time Library                   *
; *     Textfile Boolean I/O                            *
; *                                                     *
; *******************************************************

        TITLE   TBOL

        INCLUDE SE.ASM

DATA    SEGMENT WORD PUBLIC
; TRUE and FALSE strings
        extrn TrueStr:dword, FalseStr:dword
DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

; Externals
        EXTRN   WritePChar:NEAR

; Publics
        PUBLIC  WriteBool

; Write standard procedure (Boolean)
WriteBool:
        ARG     FileP,DWORD,1
        ARG     Value,BYTE,2
        ARG     Width,WORD,1

        ENTRY   WINFAR
        PUSH    FileP.seg
        PUSH    FileP.ofs
        CMP     Value,0
        les ax, TrueStr
				jne @@1
				les ax, FalseStr
@@1:    push es
        PUSH    AX
        PUSH    Width
        PUSH    CS
        CALL    WritePChar
        ADD     SP,4
        EXIT    4

CODE    ENDS

        END
